diff --git a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
index ca04ca569..b8973b353 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonBlockModel.java
@@ -4,20 +4,39 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.logic.PistonDirections;
-import net.minecraft.core.block.piston.BasePistonBlock;
+import net.minecraft.core.block.piston.PistonBaseBlock;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 
-public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockModel<T> {
+public class PistonBlockModel<T extends PistonBaseBlock> extends StandardBlockModel<T> {
     private final IconCoordinate faceTexture;
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/piston_side");
     protected IconCoordinate topTexture = TextureRegistry.getTexture("minecraft:block/piston_top");
     protected IconCoordinate bottomTexture = TextureRegistry.getTexture("minecraft:block/piston_bottom");
+
+    protected final double headThickness;
     public PistonBlockModel(Block block, IconCoordinate faceTexture){
+        this(block, faceTexture, 4/16d);
+    }
+
+    public PistonBlockModel(Block block, IconCoordinate faceTexture, double headThickness){
         super(block);
+        this.headThickness = headThickness;
         this.faceTexture = faceTexture;
     }
+
+    public PistonBlockModel<T> setPistonTextures(IconCoordinate sideTexture, IconCoordinate topTexture, IconCoordinate bottomTexture) {
+        this.sideTexture = sideTexture;
+        this.topTexture = topTexture;
+        this.bottomTexture = bottomTexture;
+        return this;
+    }
+
+    public PistonBlockModel<T> setPistonTextures(String sideTexture, String topTexture, String bottomTexture) {
+        return setPistonTextures(TextureRegistry.getTexture(sideTexture), TextureRegistry.getTexture(topTexture), TextureRegistry.getTexture(bottomTexture));
+    }
+
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z){
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
@@ -33,51 +52,51 @@ public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockMo
     protected boolean renderPistonBase(Tessellator tessellator, int x, int y, int z, boolean noCulling) {
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
         boolean extended = noCulling || (meta & 8) != 0;
-        int direction = BasePistonBlock.getDirection(meta);
+        Direction direction = PistonBaseBlock.getDirection(meta);
         if(extended)
         {
             switch(direction)
             {
-                case 0: // '\0'
+                case DOWN: // '\0'
                     renderBlocks.uvRotateEast = 3;
                     renderBlocks.uvRotateWest = 3;
                     renderBlocks.uvRotateSouth = 3;
                     renderBlocks.uvRotateNorth = 3;
-                    block.setBlockBounds(0.0F, 0.25F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    block.setBlockBounds(0.0F, headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
-                case 1: // '\001'
-                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.75F, 1.0F);
+                case UP: // '\001'
+                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1 - headThickness, 1.0F);
                     break;
 
-                case 2: // '\002'
+                case NORTH: // '\002'
                     renderBlocks.uvRotateSouth = 1;
                     renderBlocks.uvRotateNorth = 2;
-                    block.setBlockBounds(0.0F, 0.0F, 0.25F, 1.0F, 1.0F, 1.0F);
+                    block.setBlockBounds(0.0F, 0.0F, headThickness, 1.0F, 1.0F, 1.0F);
                     break;
 
-                case 3: // '\003'
+                case SOUTH: // '\003'
                     renderBlocks.uvRotateSouth = 2;
                     renderBlocks.uvRotateNorth = 1;
                     renderBlocks.uvRotateTop = 3;
                     renderBlocks.uvRotateBottom = 3;
-                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.75F);
+                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 1 - headThickness);
                     break;
 
-                case 4: // '\004'
+                case WEST: // '\004'
                     renderBlocks.uvRotateEast = 1;
                     renderBlocks.uvRotateWest = 2;
                     renderBlocks.uvRotateTop = 2;
                     renderBlocks.uvRotateBottom = 1;
-                    block.setBlockBounds(0.25F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                    block.setBlockBounds(headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                     break;
 
-                case 5: // '\005'
+                case EAST: // '\005'
                     renderBlocks.uvRotateEast = 2;
                     renderBlocks.uvRotateWest = 1;
                     renderBlocks.uvRotateTop = 1;
                     renderBlocks.uvRotateBottom = 2;
-                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 0.75F, 1.0F, 1.0F);
+                    block.setBlockBounds(0.0F, 0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F);
                     break;
             }
             renderStandardBlock(tessellator, block, x, y, z);
@@ -87,33 +106,33 @@ public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockMo
         {
             switch(direction)
             {
-                case 0: // '\0'
+                case DOWN: // '\0'
                     renderBlocks.uvRotateEast = 3;
                     renderBlocks.uvRotateWest = 3;
                     renderBlocks.uvRotateSouth = 3;
                     renderBlocks.uvRotateNorth = 3;
                     break;
 
-                case 2: // '\002'
+                case NORTH: // '\002'
                     renderBlocks.uvRotateSouth = 1;
                     renderBlocks.uvRotateNorth = 2;
                     break;
 
-                case 3: // '\003'
+                case SOUTH: // '\003'
                     renderBlocks.uvRotateSouth = 2;
                     renderBlocks.uvRotateNorth = 1;
                     renderBlocks.uvRotateTop = 3;
                     renderBlocks.uvRotateBottom = 3;
                     break;
 
-                case 4: // '\004'
+                case WEST: // '\004'
                     renderBlocks.uvRotateEast = 1;
                     renderBlocks.uvRotateWest = 2;
                     renderBlocks.uvRotateTop = 2;
                     renderBlocks.uvRotateBottom = 1;
                     break;
 
-                case 5: // '\005'
+                case EAST: // '\005'
                     renderBlocks.uvRotateEast = 2;
                     renderBlocks.uvRotateWest = 1;
                     renderBlocks.uvRotateTop = 1;
@@ -137,14 +156,14 @@ public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockMo
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        int direction = BasePistonBlock.getDirection(data);
-        if (direction > 5)
+        Direction direction = PistonBaseBlock.getDirection(data);
+        if (direction == Direction.NONE)
         {
             return atlasIndices[0];
         }
-        if (side.getId() == direction)
+        if (side.getDirection() == direction)
         {
-            if (BasePistonBlock.isPowered(data) || block.minX > 0.0D || block.minY > 0.0D || block.minZ > 0.0D || block.maxX < 1.0D || block.maxY < 1.0D || block.maxZ < 1.0D)
+            if (PistonBaseBlock.isPowered(data) || block.minX > 0.0D || block.minY > 0.0D || block.minZ > 0.0D || block.maxX < 1.0D || block.maxY < 1.0D || block.maxZ < 1.0D)
             {
                 return topTexture;
             }
@@ -153,6 +172,6 @@ public class PistonBlockModel<T extends BasePistonBlock> extends StandardBlockMo
                 return atlasIndices[0];
             }
         }
-        return side.getId() != PistonDirections.directionMap[direction] ? sideTexture : bottomTexture;
+        return side.getDirection() != direction.getOpposite() ? sideTexture : bottomTexture;
     }
 }
diff --git a/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
index cee28d051..0c49435fd 100644
--- a/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/PistonHeadBlockModel.java
@@ -5,19 +5,29 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.logic.PistonDirections;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.piston.PistonHeadBlock;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 
 public class PistonHeadBlockModel extends StandardBlockModel<PistonHeadBlock> {
-    protected IconCoordinate pistonSide = TextureRegistry.getTexture("minecraft:block/piston_side");
+    protected IconCoordinate pistonSide;
     protected IconCoordinate pistonDry = TextureRegistry.getTexture("minecraft:block/piston_face");
     protected IconCoordinate pistonSticky = TextureRegistry.getTexture("minecraft:block/piston_face_sticky");
+    protected IconCoordinate pistonSteel = TextureRegistry.getTexture("minecraft:block/piston_face_steel");
     @Nullable
     public IconCoordinate faceTextureOverride;
-    public PistonHeadBlockModel(Block block) {
+
+    protected final double headThickness;
+    public PistonHeadBlockModel(Block block, IconCoordinate pistonSide) {
+        this(block, pistonSide, 4/16d);
+    }
+
+    public PistonHeadBlockModel(Block block, IconCoordinate pistonSide, double headThickness) {
         super(block);
+        this.pistonSide = pistonSide;
+        this.headThickness = headThickness;
     }
 
     @Override
@@ -35,7 +45,7 @@ public class PistonHeadBlockModel extends StandardBlockModel<PistonHeadBlock> {
     }
     protected boolean renderPistonHead(Tessellator tessellator, PistonHeadBlock block, int x, int y, int z, boolean flag) {
         int metadata = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        int direction = PistonHeadBlock.getDirectionFromMeta(metadata);
+        Direction direction = PistonHeadBlock.getDirectionFromMeta(metadata);
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
         	tessellator.setLightmapCoord(block.getLightmapCoord(renderBlocks.blockAccess, x, y, z));
@@ -46,76 +56,76 @@ public class PistonHeadBlockModel extends StandardBlockModel<PistonHeadBlock> {
         double width = flag ? 1 : 1/2d;
         switch(direction)
         {
-            case 0: // BOTTOM
+            case DOWN: // BOTTOM
                 renderBlocks.uvRotateEast = 3;
                 renderBlocks.uvRotateWest = 3;
                 renderBlocks.uvRotateSouth = 3;
                 renderBlocks.uvRotateNorth = 3;
-                block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.25F, 1.0F);
+                block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, headThickness, 1.0F);
                 renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + 0.25F, (float)y + 0.25F + f1, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + 0.25F, (float)y + 0.25F + f1, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + 0.25F, (float)y + 0.25F + f1, (float)z + 0.375F, (float)z + 0.625F, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + 0.25F, (float)y + 0.25F + f1, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.375F, (float)z + 0.625F, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + headThickness, (float)y + headThickness + f1, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.6F, width);
                 break;
 
-            case 1: // TOP
-                block.setBlockBounds(0.0F, 0.75F, 0.0F, 1.0F, 1.0F, 1.0F);
+            case UP: // TOP
+                block.setBlockBounds(0.0F, 1 - headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
                 renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.625F, (((float)y - 0.25F) + 1.0F) - f1, ((float)y - 0.25F) + 1.0F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.375F, (((float)y - 0.25F) + 1.0F) - f1, ((float)y - 0.25F) + 1.0F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.8F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.375F, (((float)y - 0.25F) + 1.0F) - f1, ((float)y - 0.25F) + 1.0F, (float)z + 0.375F, (float)z + 0.625F, brightness * 0.6F, width);
-                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.625F, (((float)y - 0.25F) + 1.0F) - f1, ((float)y - 0.25F) + 1.0F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.625F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.375F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.8F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.375F, (float)x + 0.375F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.375F, (float)z + 0.625F, brightness * 0.6F, width);
+                renderHeadTopBottom(tessellator, (float)x + 0.625F, (float)x + 0.625F, (((float)y - headThickness) + 1.0F) - f1, ((float)y - headThickness) + 1.0F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.6F, width);
                 break;
 
-            case 2: // NORTH
+            case NORTH: // NORTH
                 renderBlocks.uvRotateSouth = 1;
                 renderBlocks.uvRotateNorth = 2;
-                block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, 0.25F);
+                block.setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, headThickness);
                 renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.375F, (float)z + 0.25F, (float)z + 0.25F + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.625F, (float)z + 0.25F, (float)z + 0.25F + f1, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.375F, (float)z + 0.25F, (float)z + 0.25F + f1, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.625F, (float)z + 0.25F, (float)z + 0.25F + f1, brightness, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.375F, (float)z + headThickness, (float)z + headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.625F, (float)z + headThickness, (float)z + headThickness + f1, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.375F, (float)z + headThickness, (float)z + headThickness + f1, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.625F, (float)z + headThickness, (float)z + headThickness + f1, brightness, width);
                 break;
 
-            case 3: // SOUTH
+            case SOUTH: // SOUTH
                 renderBlocks.uvRotateSouth = 2;
                 renderBlocks.uvRotateNorth = 1;
                 renderBlocks.uvRotateTop = 3;
                 renderBlocks.uvRotateBottom = 3;
-                block.setBlockBounds(0.0F, 0.0F, 0.75F, 1.0F, 1.0F, 1.0F);
+                block.setBlockBounds(0.0F, 0.0F, 1 - headThickness, 1.0F, 1.0F, 1.0F);
                 renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.375F, (((float)z - 0.25F) + 1.0F) - f1, ((float)z - 0.25F) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.625F, (((float)z - 0.25F) + 1.0F) - f1, ((float)z - 0.25F) + 1.0F, brightness * 0.6F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.375F, (((float)z - 0.25F) + 1.0F) - f1, ((float)z - 0.25F) + 1.0F, brightness * 0.5F, width);
-                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.625F, (((float)z - 0.25F) + 1.0F) - f1, ((float)z - 0.25F) + 1.0F, brightness, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.375F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.625F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness * 0.6F, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.375F, (float)x + 0.625F, (float)y + 0.375F, (float)y + 0.375F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness * 0.5F, width);
+                renderHeadNorthSouth(tessellator, (float)x + 0.625F, (float)x + 0.375F, (float)y + 0.625F, (float)y + 0.625F, (((float)z - headThickness) + 1.0F) - f1, ((float)z - headThickness) + 1.0F, brightness, width);
                 break;
 
-            case 4: // WEST
+            case WEST: // WEST
                 renderBlocks.uvRotateEast = 1;
                 renderBlocks.uvRotateWest = 2;
                 renderBlocks.uvRotateTop = 2;
                 renderBlocks.uvRotateBottom = 1;
-                block.setBlockBounds(0.0F, 0.0F, 0.0F, 0.25F, 1.0F, 1.0F);
+                block.setBlockBounds(0.0F, 0.0F, 0.0F, headThickness, 1.0F, 1.0F);
                 renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadEastWest(tessellator, (float)x + 0.25F, (float)x + 0.25F + f1, (float)y + 0.375F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, (float)x + 0.25F, (float)x + 0.25F + f1, (float)y + 0.625F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.625F, brightness, width);
-                renderHeadEastWest(tessellator, (float)x + 0.25F, (float)x + 0.25F + f1, (float)y + 0.375F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, (float)x + 0.25F, (float)x + 0.25F + f1, (float)y + 0.625F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.375F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.625F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.625F, brightness, width);
+                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.375F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, (float)x + headThickness, (float)x + headThickness + f1, (float)y + 0.625F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.6F, width);
                 break;
 
-            case 5: // EAST
+            case EAST: // EAST
                 renderBlocks.uvRotateEast = 2;
                 renderBlocks.uvRotateWest = 1;
                 renderBlocks.uvRotateTop = 1;
                 renderBlocks.uvRotateBottom = 2;
-                block.setBlockBounds(0.75F, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
+                block.setBlockBounds(1 - headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
                 renderStandardBlock(tessellator, block, x, y, z);
-                renderHeadEastWest(tessellator, (((float)x - 0.25F) + 1.0F) - f1, ((float)x - 0.25F) + 1.0F, (float)y + 0.375F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.5F, width);
-                renderHeadEastWest(tessellator, (((float)x - 0.25F) + 1.0F) - f1, ((float)x - 0.25F) + 1.0F, (float)y + 0.625F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.625F, brightness, width);
-                renderHeadEastWest(tessellator, (((float)x - 0.25F) + 1.0F) - f1, ((float)x - 0.25F) + 1.0F, (float)y + 0.375F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.6F, width);
-                renderHeadEastWest(tessellator, (((float)x - 0.25F) + 1.0F) - f1, ((float)x - 0.25F) + 1.0F, (float)y + 0.625F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.375F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.375F, brightness * 0.5F, width);
+                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.625F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.625F, brightness, width);
+                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.375F, (float)y + 0.625F, (float)z + 0.375F, (float)z + 0.375F, brightness * 0.6F, width);
+                renderHeadEastWest(tessellator, (((float)x - headThickness) + 1.0F) - f1, ((float)x - headThickness) + 1.0F, (float)y + 0.625F, (float)y + 0.375F, (float)z + 0.625F, (float)z + 0.625F, brightness * 0.6F, width);
                 break;
         }
         resetRenderBlocks();
@@ -182,21 +192,23 @@ public class PistonHeadBlockModel extends StandardBlockModel<PistonHeadBlock> {
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        int direction = PistonHeadBlock.getDirectionFromMeta(data);
-        if(side.getId() == direction)
+        Direction direction = PistonHeadBlock.getDirectionFromMeta(data);
+        if(side.getDirection() == direction)
         {
             if(faceTextureOverride != null)
             {
                 return faceTextureOverride;
             }
-            if((data & 8) != 0)
-            {
-                return pistonSticky;
-            } else
-            {
-                return pistonDry;
+            switch (PistonHeadBlock.getPistonType(data)) {
+                case PistonHeadBlock.TYPE_NORMAL:
+                    return pistonDry;
+                case PistonHeadBlock.TYPE_STICKY:
+                    return pistonSticky;
+                case PistonHeadBlock.TYPE_STEEL:
+                    return pistonSteel;
             }
         }
-        return side.getId() != PistonDirections.directionMap[direction] ? pistonSide : pistonDry;
+        boolean isSteel = block == Blocks.PISTON_HEAD_STEEL; // Todo this is just awful
+        return side.getDirection() != direction.getOpposite() ? pistonSide : ((isSteel) ? pistonSteel : pistonDry); // TODO remove this horrid ternary
     }
 }
